%define         major              2
%define         libname            %mklibname %{name} %{major}
%define         devname            %mklibname -d %{name}

%define         clientname         %{name}-client
%define         servername         %{name}-server
%define         schedname          %{name}-sched
%define         momname            %{name}-mom
%define         guiname            %{name}-gui


#default is /var/spool/torque: if you change this, you'll break some
#scripts coming along with the source files
%define         torquedir          /var/spool/torque


Name:           torque
Summary:        The Torque resource and queue manager
Group:          System/Cluster
Version:        4.1.5.1
Release:        %mkrel 1
License:        TORQUEv1.1
URL:            http://www.clusterresources.com/products/torque-resource-manager.php

Source0:        %{name}-%{version}.tar.gz
Source1:        mom_config
Source2:        README.mga


# add LSB info + fixes various bugs in pbs_server
Patch0:         torque-4.1.1-initdserver.patch
Patch1:         torque-4.1.1-initdsched.patch
Patch2:         torque-4.1.1-initdmom.patch
Patch3:         torque-4.1.1-initdtrqauthd.patch


BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  groff
BuildRequires:  groff-for-man
BuildRequires:  sed
BuildRequires:  xauth
BuildRequires:  gperf
BuildRequires:  graphviz
BuildRequires:  latex
BuildRequires:  doxygen
BuildRequires:  glibc-devel
BuildRequires:  binutils-devel
BuildRequires:  libncurses-devel
BuildRequires:  libreadline-devel
BuildRequires:  tk-devel
BuildRequires:  tcl-devel
BuildRequires:  tclx-devel
BuildRequires:  openssh-clients
BuildRequires:  readline-devel
BuildRequires:  gcc-gfortran
BuildRequires:  gcc-c++
%ifarch %ix86 x86_64
BuildRequires:  quadmath-devel
%endif
BuildRequires:  pam-devel
BuildRequires:  openssl-devel
BuildRequires:  libxml2-devel
BuildRequires:  hwloc
BuildRequires:  hwloc-devel

Requires:       openssh-clients 
Suggests:       torque-mom

%description
The Tera-scale Open-source Resource and QUEue manager provides control
over batch jobs and distributed computing resources. It is an advanced
open-source product based on the original PBS project* and
incorporates the best of both community and professional
development. It incorporates significant advances in the areas of
scalability, reliability, and functionality and is currently in use at
tens of thousands of leading government, academic, and commercial
sites throughout the world.

"TORQUE is a modification of OpenPBS which was developed by NASA Ames
Research Center, Lawrence Livermore National Laboratory, and Veridian
Information Solutions, Inc. Visit www.clusterresources.com/products/
for more information about TORQUE and to download TORQUE".



%package -n     %{libname}
Summary:        Shared libraries for Torque
Group:          System/Libraries
Provides:       lib%{name} = %{version}-%{release}

%description -n %{libname}
%{summary}.



%package -n     %{devname}
Summary:        Development files for Torque
Group:          Development/Other
Requires:       %{libname} = %{version}-%{release}
Provides:       lib%{name}-devel  = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{devname}
%{summary}.



%package -n    %{clientname}
Summary:        Command line utilities for Torque
Group:          System/Cluster
Requires:       %{libname} = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}

%description -n %{clientname}
%{summary}.



%package -n     %{servername}
Summary:        The Torque server
Group:          System/Cluster
Requires:       %{libname} = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}
Suggests:       %{schedname} = %{version}-%{release}
Requires(post): rpm-helper
Requires(preun):rpm-helper

%description -n %{servername}
%{summary}.



%package -n     %{schedname}
Summary:        The scheduler for Torque server
Group:          System/Cluster
Requires:       %{libname} = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}
Requires:       %{servername} = %{version}-%{release}
Requires(post): rpm-helper
Requires(preun):rpm-helper

%description -n %{schedname}
%{summary}.



%package -n     %{momname}
Summary:        Node manager programs for Torque
Group:          System/Cluster
Requires:       %{libname} = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}
Requires:       openssh-server
Requires(post): rpm-helper
Requires(preun):rpm-helper

%description -n %{momname}
%{summary}.  



%package -n     %{guiname}
Summary:        Graphical clients for Torque
Group:          Monitoring
Requires:       tk
Requires:       tcl
Requires:       %{libname} = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-client = %{version}-%{release}
Obsoletes:      torque-xpbs <= 2.5.3

%description -n %{guiname}
%{summary}.


%prep
%setup -q
%patch0 -p1 -b .old
%patch1 -p1 -b .old
%patch2 -p1 -b .old
%patch3 -p1 -b .old



%build
%configure2_5x \
                --srcdir=%{_builddir}/%{name}-%{version} \
                --includedir=%{_includedir}/%{name} \
                --with-default-server=localhost \
                --with-pam=%{_libdir}/security \
                --with-rcp=scp \
                --with-hwloc-path=%{_prefix} \
                --enable-docs \
                --enable-server \
                --enable-mom \
                --enable-client \
                --enable-drmaa \
                --enable-high-availability \
                --enable-syslog \
                --enable-gui \
                --disable-static
#                --enable-numa-support \
#                --enable-cpuset \

%make all \
                XPBS_DIR=%{tcl_sitelib}/xpbs \
                XPBSMON_DIR=%{tcl_sitelib}/xpbsmon






%install
%makeinstall_std \
                PBS_SERVER_HOME=%{torquedir} \
                mandir=%_mandir \
                XPBS_DIR=%{tcl_sitelib}/xpbs \
                XPBSMON_DIR=%{tcl_sitelib}/xpbsmon


find %{buildroot}%{_libdir} -name *.la -delete

#yields various service to fail if relative symlinks
export DONT_RELINK=1

#install starting scripts
%__mkdir_p %{buildroot}%{_initrddir}
install -p -m 755 contrib/init.d/pbs_mom    %{buildroot}%{_initrddir}/pbs_mom
install -p -m 755 contrib/init.d/pbs_sched  %{buildroot}%{_initrddir}/pbs_sched
install -p -m 755 contrib/init.d/pbs_server %{buildroot}%{_initrddir}/pbs_server
install -p -m 755 contrib/init.d/trqauthd %{buildroot}%{_initrddir}/trqauthd
#end starting scripts


#install config files: move them to /etc/torque
%__mkdir_p %{buildroot}%{_sysconfdir}/%{name}
pushd %{buildroot}%{torquedir}
%__mv server_name     %{buildroot}%{_sysconfdir}/%{name}
%__ln_s               %{_sysconfdir}/%{name}/server_name .
popd

pushd %{buildroot}%{torquedir}/server_priv
%__mv nodes %{buildroot}%{_sysconfdir}/%{name}
%__ln_s     %{_sysconfdir}/%{name}/nodes .
popd

pushd %{buildroot}%{torquedir}/sched_priv
%__mv sched_config   %{buildroot}%{_sysconfdir}/%{name}
%__mv dedicated_time %{buildroot}%{_sysconfdir}/%{name}
%__mv holidays       %{buildroot}%{_sysconfdir}/%{name}
%__mv resource_group %{buildroot}%{_sysconfdir}/%{name}
%__ln_s               %{_sysconfdir}/%{name}/sched_config .
%__ln_s               %{_sysconfdir}/%{name}/dedicated_time .
%__ln_s               %{_sysconfdir}/%{name}/holidays .
%__ln_s               %{_sysconfdir}/%{name}/resource_group .
popd

install -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/%{name}
pushd %{buildroot}%{torquedir}/mom_priv
%__ln_s %{_sysconfdir}/%{name}/mom_config config


popd
#end config files


#move drmaa man to the right place
%__mv %{buildroot}%{_defaultdocdir}/torque-drmaa/man/man3/* %{buildroot}%{_mandir}/man3/.
install -D -m 644 %{SOURCE2} %{buildroot}%{_docdir}/%{name}/README.mga


#make symbolic links for tcl
pushd %{buildroot}%{_libdir}
%__ln_s %{tcl_sitelib}/xpbs    .
%__ln_s %{tcl_sitelib}/xpbsmon .
popd


#clean make install bugs the dirty way...
%__rm -f %{buildroot}%{_mandir}/man1/basl2c.1*
%__rm -f %{buildroot}%{_mandir}/man3/_*src_drmaa_src_.3*




%post
#update of /etc/services
CHECK_PORT=`grep 15003 /etc/services`
if [ -z "$CHECK_PORT" ]; then
          cat >> /etc/services << EOF
# Standard Torque/PBS services
pbs_server      15001/tcp   # pbs server
pbs_server      15001/udp   # pbs server
pbs_mom         15002/tcp   # mom to/from server
pbs_mom         15002/udp   # mom to/from server
pbs_resmon      15003/tcp   # mom resource management requests
pbs_resmon      15003/udp   # mom resource management requests
pbs_sched       15004/tcp   # scheduler 
pbs_sched       15004/udp   # scheduler
trqauthd        15005/tcp   #authd
trqauthd        15005/udp   #authd
EOF
fi
#end update


%post -n %{momname}
%_post_service pbs_mom

%preun -n %{momname}
%_preun_service pbs_mom

%post -n %{servername}
%_post_service pbs_server

%preun -n %{servername}
%_preun_service pbs_server

%post -n %{schedname}
%_post_service pbs_sched

%preun -n %{schedname}
%_preun_service pbs_sched

%post -n %{clientname}
%_post_service trqauthd

%preun -n %{clientname}
%_preun_service trqauthd



%files
%doc PBS_License.txt Release_Notes README.torque
%doc README.NUMA README.trqauthd README.array_changes
%dir %{torquedir}
%dir %{torquedir}/checkpoint
%dir %{torquedir}/aux
%dir %{torquedir}/spool
%dir %{torquedir}/undelivered
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/server_name
%{torquedir}/server_name
%{torquedir}/pbs_environment
%{_libdir}/security/pam*
%{_mandir}/man1/pbs.1.*



%files -n %{libname}
%doc CHANGELOG README.coding_notes README.building_40 README.configure
%{_libdir}/*.so.*



%files -n %{devname}
%doc 
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*
%{_bindir}/pbs-config
%{_libdir}/*.so
%{_defaultdocdir}/torque-drmaa
%{_mandir}/man3/*.h.3*
%{_mandir}/man3/pbs_*.3*
%{_mandir}/man3/rpp.3*
%{_mandir}/man3/tm.3*
%{_mandir}/man3/drmaa.3*
%{_mandir}/man3/drmaa_*.3*



%files -n %{clientname}
%doc
%{_initrddir}/trqauthd
%{_sbindir}/trqauthd
%{_bindir}/qa*
%{_bindir}/qc*
%{_bindir}/qdel
%{_bindir}/qg*
%{_bindir}/qh*
%{_bindir}/qm*
%{_bindir}/qo*
%{_bindir}/qrerun
%{_bindir}/qrls
%{_bindir}/qsub
%{_bindir}/qstat
%{_bindir}/qsig
%{_bindir}/qselect
%{_bindir}/chk_tree
%{_bindir}/hostn
%{_bindir}/nqs2pbs
%{_bindir}/pbsnodes
%{_bindir}/qnodes
%{_bindir}/pbsdsh
%{_bindir}/qterm
%{_bindir}/qstop
%{_bindir}/qstart
%{_bindir}/qdisable
%{_bindir}/qenable
%{_bindir}/qrun
%{_mandir}/man1/q*.1*
%{_mandir}/man1/nqs2pbs.1*
%{_mandir}/man1/pbsdsh.1*
%{_mandir}/man3/jobs.3*
%{_mandir}/man7/pbs_*.7*
%{_mandir}/man8/pbsnodes.8*
%{_mandir}/man8/q*.8*



%files -n %{servername}
%dir %{torquedir}/server_priv
%dir %{torquedir}/server_priv/acl_svr
%dir %{torquedir}/server_priv/acl_groups
%dir %{torquedir}/server_priv/acl_hosts
%dir %{torquedir}/server_priv/acl_users
%dir %{torquedir}/server_priv/accounting
%dir %{torquedir}/server_priv/arrays
%dir %{torquedir}/server_priv/credentials
%dir %{torquedir}/server_priv/disallowed_types
%dir %{torquedir}/server_priv/hostlist
%dir %{torquedir}/server_priv/jobs
%dir %{torquedir}/server_priv/queues
%config(noreplace) %{_sysconfdir}/%{name}/nodes
%{torquedir}/server_priv/nodes
%{_initrddir}/pbs_server
%{_sbindir}/pbs_server
%{_sbindir}/qserverd
%{_bindir}/pbs_track
%{_bindir}/tracejob
%{_bindir}/printjob
%{_bindir}/printserverdb
%{_bindir}/printtracking
%{_mandir}/man8/pbs_server.8*




%files -n %{schedname}
%dir %{torquedir}/sched_priv
%dir %{torquedir}/sched_priv/accounting
%dir %{torquedir}/sched_logs
%config(noreplace) %{_sysconfdir}/%{name}/sched_config 
%config(noreplace) %{_sysconfdir}/%{name}/dedicated_time 
%config(noreplace) %{_sysconfdir}/%{name}/holidays 
%config(noreplace) %{_sysconfdir}/%{name}/resource_group
%{torquedir}/sched_priv/sched_config
%{torquedir}/sched_priv/dedicated_time
%{torquedir}/sched_priv/holidays
%{torquedir}/sched_priv/resource_group
%{_initrddir}/pbs_sched
%{_sbindir}/pbs_sched
%{_sbindir}/qschedd
%{_mandir}/man8/pbs_sched*.8*




%files -n %{momname}
%doc
%dir %{torquedir}/mom_priv
%dir %{torquedir}/mom_priv/jobs
%dir %{torquedir}/mom_logs
%config(noreplace) %{_sysconfdir}/%{name}/mom_config
%{torquedir}/mom_priv/config
%{_initrddir}/pbs_mom
%{_sbindir}/pbs_mom
%{_sbindir}/qnoded
%{_sbindir}/momctl
%{_sbindir}/pbs_demux
#attr(4755, root, root) {_sbindir}/pbs_iff
%{_mandir}/man8/pbs_mom.8*




%files -n %{guiname}
%{_bindir}/xpbs*
%{_bindir}/pbs_wish
%{_bindir}/pbs_tclsh
%{tcl_sitelib}/xpbs
%{tcl_sitelib}/xpbsmon
%{_libdir}/xpbs
%{_libdir}/xpbsmon
%{_mandir}/man1/xpbs*.1*



%changelog

* Wed Apr 03 2013 eatdirt <eatdirt> 4.1.5.1-1.mga3
+ Revision: 407379
- Upgrade to 4.1.5.1 (bugs fix release)

* Mon Jan 14 2013 umeabot <umeabot> 4.1.4-2.mga3
+ Revision: 384682
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 eatdirt <eatdirt> 4.1.4-1.mga3
+ Revision: 343214
- Upgrade to version 4.1.4

  + rtp <rtp>
    - fix build-dep

* Thu Nov 01 2012 eatdirt <eatdirt> 4.1.3-1.mga3
+ Revision: 312289
- Upgrade to version 4.1.3

* Sun Sep 02 2012 eatdirt <eatdirt> 4.1.1-1.mga3
+ Revision: 287155
- Upgrading to branch 4.1.1

* Sat Aug 25 2012 eatdirt <eatdirt> 2.5.12-2.mga3
+ Revision: 283811
- Fixing missing Obsolete and Deps

* Fri Aug 24 2012 eatdirt <eatdirt> 2.5.12-1.mga3
+ Revision: 283731
- Upgrade to 2.5.12 (latest of branch 2), specfile rewritten from scratch

* Sun Apr 29 2012 colin <colin> 2.5.3-4.mga2
+ Revision: 234229
- Disable unused-but-set-variable error checks (breaks build)
- Add LSB headers to initscripts (mga#5262)

* Wed Jul 06 2011 fwang <fwang> 2.5.3-3.mga2
+ Revision: 119194
- disable tcl 8.6 patch
- br openssh-clients
- rebuild for new tcl

* Tue Jun 28 2011 ahmad <ahmad> 2.5.3-2.mga2
+ Revision: 115316
- Drop the buildroot declaration
- Drop old/unneeded scriptlets
- imported package torque


* Sun Nov 28 2010 Sandro Cazzaniga <kharec@mandriva.org> 2.5.3-1mdv2011.0
+ Revision: 602397
- new version 2.5.3

  + Lev Givon <lev@mandriva.org>
    - Forgot to remove 2.4.5 tarball.

* Mon May 10 2010 Antoine Ginies <aginies@mandriva.com> 2.4.8-1mdv2010.1
+ Revision: 544318
- release 2.4.8

* Tue Feb 09 2010 Antoine Ginies <aginies@mandriva.com> 2.4.5-1mdv2010.1
+ Revision: 502714
- release 2.4.5

  + Giuseppe Ghibò <ghibo@mandriva.com>
    - Let Patch14 for TCL 8.6 conditional (needed for backporting over older tcl versions).

* Thu Jul 23 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.3.7-1mdv2010.0
+ Revision: 398757
- bump major
- place library in it's own separate package rather than in the devel package
- cleanups
- regenerate P14
- drop dead patches
- new release: 2.3.7
- add readline-devel to buildrequires
- use %%configure2_5x macro
- fix string format issues (P0)
- regenarate P9, P13, P14
- drop Prefix tag
- drop unused patches
- new release: 2.1.11

* Sat Dec 06 2008 Adam Williamson <awilliamson@mandriva.org> 2.1.7-6mdv2009.1
+ Revision: 310969
- rebuild for new tcl
- install to new location per policy
- make sure everything's on the same page with regards to /var/spool/pbs
- fix a code bug that prevents xpbs running
- add tcl86.patch (fix/kludge build for tcl 8.6)
- fix a #%%define

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild
    - rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Fri Dec 21 2007 Olivier Blin <oblin@mandriva.com> 2.1.7-3mdv2008.1
+ Revision: 136550
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request
    - buildrequires X11-devel instead of XFree86-devel
    - kill packager tag

* Fri Sep 07 2007 Anssi Hannula <anssi@mandriva.org> 2.1.7-3mdv2008.0
+ Revision: 82052
- rebuild for new soname of tcl

* Fri Jun 22 2007 Thierry Vignaud <tv@mandriva.org> 2.1.7-2mdv2008.0
+ Revision: 42958
- uncompress a patch, thus fixing build
- fix group


* Tue Feb 27 2007 Olivier Thauvin <nanardon@mandriva.org> 2.1.7-1mdv2007.0
+ Revision: 126203
- fix buildrequirements
- clean up patch
- fix path installation
- 2.1.7

  + Lev Givon <lev@mandriva.org>
    - Import torque

* Wed Jan 04 2006 Oden Eriksson <oeriksson@mandriva.com> 2.0.0-2mdk
- rebuilt against soname aware deps (tcl/tk)
- fix deps

* Thu Nov 17 2005 Antoine Ginies <aginies@n3.mandriva.com> 2.0.0-1mdk
- release 2.0.0p1

* Thu Mar 17 2005 Antoine Ginies <aginies@mandrakesoft.com> 1.2.0-1mdk
- release 1.2.0p1
- fix acces to xpbs and xpbsmon

* Tue Jun 22 2004 Erwan Velu <erwan@mandrakesoft.com> 1.1.0-1mdk
- 1.1.0

* Thu May 06 2004 Erwan Velu <erwan@mandrakesoft.com> 1.0.1-7mdk
- Fixing wrong rights on /usr/include/torque

* Thu Apr 22 2004 Erwan Velu <erwan@mandrakesoft.com> 1.0.1-6mdk
- Adding Torque1.0.1p6-comment.diff

* Tue Apr 20 2004 Erwan Velu <erwan@mandrakesoft.com> 1.0.1-5mdk
- Release p6
- Adding %%subrelease to builddir

* Tue Mar 02 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.0.1-4mdk
- Fix DIRM (distlint)
- Fix dep wish8.3

* Mon Mar 01 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.0.1-3mdk
- fix -devel provides

* Mon Mar 01 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.0.1-2mdk
- Provides/Obsoletes: PBS

